﻿# -*- coding: utf-8 -*-
#######################################################################################################
#
#    MediaPortal for Dreambox OS
#
#    Coded by MediaPortal Team (c) 2013-2021
#
#  This plugin is open source but it is NOT free software.
#
#  This plugin may only be distributed to and executed on hardware which
#  is licensed by Dream Property GmbH. This includes commercial distribution.
#  In other words:
#  It's NOT allowed to distribute any parts of this plugin or its source code in ANY way
#  to hardware which is NOT licensed by Dream Property GmbH.
#  It's NOT allowed to execute this plugin and its source code or even parts of it in ANY way
#  on hardware which is NOT licensed by Dream Property GmbH.
#
#  This applies to the source code as a whole as well as to parts of it, unless explicitely
#  stated otherwise.
#
#  If you want to use or modify the code or parts of it, permission from the authors is necessary.
#  You have to keep OUR license and inform us about any modification, but it may NOT be distributed
#  other than under the conditions noted above.
#
#  As an exception regarding modifcations, you are NOT permitted to remove
#  any copy protections implemented in this plugin or change them for means of disabling
#  or working around the copy protections, unless the change has been explicitly permitted
#  by the original authors. Also decompiling and modification of the closed source
#  parts is NOT permitted.
#
#  Advertising with this plugin is NOT allowed.
#
#  For other uses, permission from the authors is necessary.
#
#######################################################################################################

from future import standard_library
standard_library.install_aliases()
from builtins import map
from ...plugin import _
from ...resources.imports import *

agent='Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.88 Safari/537.36'
json_headers = {
	'Accept': 'application/json',
	'Accept-Language': 'en,en-US;q=0.7,en;q=0.3',
	'X-Requested-With': 'XMLHttpRequest',
	'Content-Type': 'application/x-www-form-urlencoded',
	}

default_cover = "file://%s/playvids.png" % (config_mp.mediaportal.iconcachepath.value + "logos")

class playvidsGenreScreen(MPScreen):

	def __init__(self, session, mode):
		self.mode = mode

		global default_cover
		if self.mode == "playvids":
			self.portal = "PlayVids.com"
			self.baseurl = "https://www.playvids.com"
			default_cover = "file://%s/playvids.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "pornflip":
			self.portal = "PornFlip.com"
			self.baseurl = "https://www.pornflip.com"
			default_cover = "file://%s/pornflip.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "peekvids":
			self.portal = "PeekVids.com"
			self.baseurl = "https://www.peekvids.com"
			default_cover = "file://%s/peekvids.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "pornoeggs":
			self.portal = "PornoEggs.com"
			self.baseurl = "https://www.pornoeggs.com"
			default_cover = "file://%s/pornoeggs.png" % (config_mp.mediaportal.iconcachepath.value + "logos")

		MPScreen.__init__(self, session, skin='MP_Plugin', default_cover=default_cover)

		self["actions"] = ActionMap(["MP_Actions"], {
			"ok" : self.keyOK,
			"0" : self.closeAll,
			"cancel" : self.keyCancel,
			"up" : self.keyUp,
			"down" : self.keyDown,
			"right" : self.keyRight,
			"left" : self.keyLeft
		}, -1)

		self['title'] = Label(self.portal)
		self['ContentTitle'] = Label("Genre:")
		self.keyLocked = True
		self.suchString = ''

		self._items = []
		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self['liste'] = self.ml

		self.onLayoutFinish.append(self.layoutFinished)

	def layoutFinished(self):
		url = "%s/categories" % self.baseurl
		twAgentGetPage(url, agent=agent).addCallback(self.genreData).addErrback(self.dataError)

	def genreData(self, data):
		parse = re.search('id="list_num"(.*?)class="section-wrapper"', data, re.S)
		if parse:
			Cats = MPfindall(self, '<li>.{0,10}<a href="((?:/category/|/c/).*?)">(.*?)</a>', parse.group(1), re.S)
			if Cats:
				for (Url, Title) in Cats:
					Url = self.baseurl + Url
					Title = upperString(Title.strip())
					self._items.append((Title, Url, default_cover))
		self._items.sort()
		if self.mode in ["playvids", "pornflip"]:
			self._items.insert(0, ("Channels", '%s/channels' % self.baseurl, default_cover))
		self._items.insert(0, ("Trending", '%s/Trending-Porn' % self.baseurl, default_cover))
		self._items.insert(0, ("Newest", '%s/' % self.baseurl, default_cover))
		self._items.insert(0, ("--- Search ---", "callSuchen", default_cover))
		self.ml.setList(list(map(self._defaultlistcenter, self._items)))
		self.ml.moveToIndex(0)
		self.keyLocked = False

	def keyOK(self):
		if self.keyLocked:
			return
		Name = self['liste'].getCurrent()[0][0]
		Link = self['liste'].getCurrent()[0][1]
		if Name == "--- Search ---":
			self.suchen(suggest_func=self.getSuggestions)
		elif Name == "Channels":
			self.session.open(playvidsChannelScreen, Link, Name, self.portal, self.baseurl)
		else:
			self.session.open(playvidsFilmScreen, Link, Name, self.portal, self.baseurl)

	def SuchenCallback(self, callback = None):
		if callback is not None and len(callback):
			self.suchString = callback
			Link = urllib.parse.quote(self.suchString.replace(' ', '+'))
			Name = "--- Search ---"
			self.session.open(playvidsFilmScreen, Link, Name, self.portal, self.baseurl)

	def getSuggestions(self, text, max_res):
		if self.mode in ["playvids", "pornflip"]:
			url = "%s/s/suggests-all?q=%s&orientation=straight" % (self.baseurl, urllib.parse.quote_plus(text))
		else:
			url = "%s/search/suggests-all?q=%s&orientation=straight" % (self.baseurl, urllib.parse.quote_plus(text))
		d = twAgentGetPage(url, agent=agent, headers=json_headers, timeout=5)
		d.addCallback(self.gotSuggestions, max_res)
		d.addErrback(self.gotSuggestions, max_res, err=True)
		return d

	def gotSuggestions(self, suggestions, max_res, err=False):
		list = []
		if not err and type(suggestions) in (str, buffer):
			suggestions = json.loads(suggestions)
			for item in suggestions["suggest"]["searches"]:
				li = item
				list.append(str(li))
				max_res -= 1
				if not max_res: break
		elif err:
			printl(str(suggestions), self, 'E')
		return list

class playvidsChannelScreen(MPScreen):

	def __init__(self, session, Link, Name, portal, baseurl):
		self.portal = portal
		self.baseurl = baseurl
		self.Link = Link
		self.Name = Name

		MPScreen.__init__(self, session, skin='MP_Plugin', default_cover=default_cover)

		self["actions"] = ActionMap(["MP_Actions"], {
			"ok" : self.keyOK,
			"0" : self.closeAll,
			"cancel" : self.keyCancel,
			"up" : self.keyUp,
			"down" : self.keyDown,
			"right" : self.keyRight,
			"left" : self.keyLeft,
			"nextBouquet" : self.keyPageUp,
			"prevBouquet" : self.keyPageDown,
			"green" : self.keyPageNumber
		}, -1)

		self['title'] = Label(self.portal)
		self['ContentTitle'] = Label("Genre: %s" % self.Name)
		self['F2'] = Label(_("Page"))

		self['Page'] = Label(_("Page:"))
		self.keyLocked = True
		self.page = 1
		self.lastpage = 1

		self._items = []
		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self['liste'] = self.ml

		self.onLayoutFinish.append(self.loadPage)

	def loadPage(self):
		self.keyLocked = True
		self._items = []
		url = "%s?page=%s" % (self.Link, str(self.page))
		twAgentGetPage(url, agent=agent).addCallback(self.genreData).addErrback(self.dataError)

	def genreData(self, data):
		self.getLastPage(data, 'class="pagination">(.*?)</ul>')
		parse = re.search('(?:href="#">Popular channels</a>|<span>Popular channels</span)(.*?)$', data, re.S)
		Cats = MPfindall(self, 'class="card-img">.*?href="(.*?)".*?<img.*?src="(.*?)"\salt="(.*?)"', parse.group(1), re.S)
		if Cats:
			for (Url, Image, Title) in Cats:
				Url = self.baseurl + Url
				if Image.startswith('/'):
					Image = self.baseurl + Image
				self._items.append((upperString(Title), Url, Image))
			self._setList('_defaultlistleft', True)
			self.ml.moveToIndex(0)
			self.keyLocked = False
			self.showInfos()

	def showInfos(self):
		Title = self['liste'].getCurrent()[0][0]
		Image = self['liste'].getCurrent()[0][2]
		self['name'].setText(Title)
		CoverHelper(self['coverArt']).getCover(Image)

	def keyOK(self):
		if self.keyLocked:
			return
		Name = self['liste'].getCurrent()[0][0]
		Link = self['liste'].getCurrent()[0][1]
		self.session.open(playvidsFilmScreen, Link, Name, self.portal, self.baseurl)

class playvidsFilmScreen(MPScreen):

	def __init__(self, session, Link, Name, portal, baseurl):
		self.portal = portal
		self.baseurl = baseurl
		self.Link = Link
		self.Name = Name

		global default_cover
		if self.portal == "PlayVids.com":
			default_cover = "file://%s/playvids.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "PornFlip.com":
			default_cover = "file://%s/pornflip.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "PeekVids.com":
			default_cover = "file://%s/peekvids.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "PornoEggs.com":
			default_cover = "file://%s/pornoeggs.png" % (config_mp.mediaportal.iconcachepath.value + "logos")

		MPScreen.__init__(self, session, skin='MP_Plugin', default_cover=default_cover)


		self["actions"] = ActionMap(["MP_Actions"], {
			"ok" : self.keyOK,
			"0" : self.closeAll,
			"cancel" : self.keyCancel,
			"up" : self.keyUp,
			"down" : self.keyDown,
			"right" : self.keyRight,
			"left" : self.keyLeft,
			"nextBouquet" : self.keyPageUp,
			"prevBouquet" : self.keyPageDown,
			"green" : self.keyPageNumber
		}, -1)

		self['title'] = Label(self.portal)
		self['ContentTitle'] = Label("Genre: %s" % self.Name)
		self['F2'] = Label(_("Page"))

		self['Page'] = Label(_("Page:"))
		self.keyLocked = True
		self.page = 1
		self.lastpage = 1

		self._items = []
		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self['liste'] = self.ml

		self.onLayoutFinish.append(self.loadPage)

	def loadPage(self):
		self.keyLocked = True
		self['name'].setText(_('Please wait...'))
		self._items = []
		if re.match(".*?Search", self.Name):
			url = "%s/sq?q=%s&page=%s" % (self.baseurl, self.Link, str(self.page))
		else:
			url = "%s?page=%s" % (self.Link, str(self.page))
		twAgentGetPage(url, agent=agent).addCallback(self.loadData).addErrback(self.dataError)

	def loadData(self, data):
		if '/t/' in self.Link or '/category/' in self.Link or re.match(".*?Search", self.Name) or self.Name in ["Newest", "Trending"]:
			self.getLastPage(data, 'class="pagination">(.*?)</ul>')
		else:
			if 'Show more items' in data:
				self.lastpage = self.page + 1
			if self.lastpage > 1:
				self['page'].setText(str(self.page) + ' / ' + str(self.lastpage))
			else:
				self['page'].setText('1 / 1')
		Movies = MPfindall(self, 'itemVideo.*?href="(.*?)".*?<img.*?src="(.*?)"\salt="(.*?)".*? class="duration.*?">(.*?)</span>.*?class="time-(?:addition|post)">(.*?)</span>', data, re.S)
		if Movies:
			for (Url, Image, Title, Runtime, Added) in Movies:
				Url = self.baseurl + Url
				Added = stripAllTags(Added).strip()
				self._items.append((Title, Url, Image, Runtime, Added))
		if len(self._items) == 0:
			self._items.append((_('No videos found!'), '', None, '', ''))
		self._setList('_defaultlistleft', True)
		self.ml.moveToIndex(0)
		self.keyLocked = False
		self.showInfos()

	def showInfos(self):
		title = self['liste'].getCurrent()[0][0]
		url = self['liste'].getCurrent()[0][1]
		pic = self['liste'].getCurrent()[0][2]
		runtime = self['liste'].getCurrent()[0][3]
		added = self['liste'].getCurrent()[0][4]
		self['handlung'].setText("Runtime: %s\nAdded: %s" % (runtime, added))
		self['name'].setText(title)
		CoverHelper(self['coverArt']).getCover(pic)

	def keyOK(self):
		if self.keyLocked:
			return
		Link = self['liste'].getCurrent()[0][1]
		self.keyLocked = True
		twAgentGetPage(Link, agent=agent).addCallback(self.getVideoPage).addErrback(self.dataError)

	def getVideoPage(self, data):
		url = MPfindall(self, 'data-hls-src\d+="(.*?)"', data, re.S)
		if url:
			url = url[-1]
			url = url.replace('&amp;', '&')
			self.keyLocked = False
			Title = self['liste'].getCurrent()[0][0]
			self.session.open(SimplePlayer, [(Title, url)], showPlaylist=False, ltype='playvids')